diff --git a/Documentation/DocBook/drm.tmpl b/Documentation/DocBook/drm.tmpl
index ed1d6d2..e15ba97 100644
--- a/Documentation/DocBook/drm.tmpl
+++ b/Documentation/DocBook/drm.tmpl
@@ -2317,6 +2317,612 @@ void intel_crt_init(struct drm_device *dev)
       pointer to the target object, a pointer to the previously created property
       and an initial instance value.
     </para>
+    <para>
+     Following table gives description of drm properties exposed by various
+     modules/drivers.
+    </para>
+<table border="1" cellpadding="0" cellspacing="0" >
+<tbody>
+<tr style="font-weight: bold;" >
+<td valign="top" >Owner Module/Drivers</td>
+<td valign="top" >Group</td>
+<td valign="top" >Property Object</td>
+<td valign="top" >Property Name</td>
+<td valign="top" >Type</td>
+<td valign="top" >Property Values</td>
+<td valign="top" >Object attached</td>
+<td valign="top" >Description</td>
+</tr>
+
+<tr>
+<td rowspan="19" valign="top" >DRM</td>
+<td rowspan="2" valign="top" >Generic Properties</td>
+<td valign="top" >edid_property</td>
+<td valign="top" >“EDID”</td>
+<td valign="top" >DRM_MODE_PROP_BLOB | DRM_MODE_PROP_IMMUTABLE</td>
+<td valign="top" >0</td>
+<td valign="top" >Connector</td>
+<td valign="top" >Contains id of edid blob ptr object.</td>
+</tr>
+
+<tr>
+<td valign="top" >dpms_property</td>
+<td valign="top" >“DPMS”</td>
+<td valign="top" >DRM_MODE_PROP_ENUM</td>
+<td valign="top" >{ DRM_MODE_DPMS_ON, “On”},
+{ DRM_MODE_DPMS_STANDBY, “Standby”},
+{ DRM_MODE_DPMS_SUSPEND, “Suspend”},
+{ DRM_MODE_DPMS_OFF, “Off”}</td>
+<td valign="top" >Connector</td>
+<td valign="top" >Contains DPMS operation mode value.</td>
+</tr>
+
+<tr>
+<td rowspan="2" valign="top" >DVI-I Properties</td>
+<td valign="top" >dvi_i_subconnector_property</td>
+<td valign="top" >“subconnector”</td>
+<td valign="top" >DRM_MODE_PROP_ENUM</td>
+<td valign="top" >{ DRM_MODE_SUBCONNECTOR_Unknown, “Unknown”},
+{ DRM_MODE_SUBCONNECTOR_DVID, “DVI-D”},
+{ DRM_MODE_SUBCONNECTOR_DVIA, “DVI-A”}</td>
+<td valign="top" >Connector</td>
+<td valign="top" >TBD</td>
+</tr>
+
+<tr>
+<td valign="top" >dvi_i_select_subconnector_property</td>
+<td valign="top" >“select subconnector”</td>
+<td valign="top" >DRM_MODE_PROP_ENUM</td>
+<td valign="top" >{ DRM_MODE_SUBCONNECTOR_Automatic, “Automatic”},
+{ DRM_MODE_SUBCONNECTOR_DVID, “DVI-D”},
+{ DRM_MODE_SUBCONNECTOR_DVIA, “DVI-A”}</td>
+<td valign="top" >Connector</td>
+<td valign="top" >TBD</td>
+</tr>
+
+<tr>
+<td rowspan="13" valign="top" >TV Properties</td>
+<td valign="top" >tv_subconnector_property</td>
+<td valign="top" >“subconnector”</td>
+<td valign="top" >DRM_MODE_PROP_ENUM</td>
+<td valign="top" >{ DRM_MODE_SUBCONNECTOR_Unknown, "Unknown"},
+{ DRM_MODE_SUBCONNECTOR_Composite, "Composite" },
+{ DRM_MODE_SUBCONNECTOR_SVIDEO, "SVIDEO"},
+{ DRM_MODE_SUBCONNECTOR_Component , "Component"},
+{ DRM_MODE_SUBCONNECTOR_SCART, "SCART"}</td>
+<td valign="top" >Connector</td>
+<td valign="top" >TBD</td>
+</tr>
+
+<tr>
+<td valign="top" >tv_select_subconnector_property</td>
+<td valign="top" >“select subconnector”</td>
+<td valign="top" >DRM_MODE_PROP_ENUM</td>
+<td valign="top" >{DRM_MODE_SUBCONNECTOR_Automatic, "Automatic"}, 
+{DRM_MODE_SUBCONNECTOR_Composite, "Composite"},
+{DRM_MODE_SUBCONNECTOR_SVIDEO, "SVIDEO"},
+{DRM_MODE_SUBCONNECTOR_Component, "Component"},
+{DRM_MODE_SUBCONNECTOR_SCART, "SCART"}</td>
+<td valign="top" >Connector</td>
+<td valign="top" >TBD</td>
+</tr>
+
+<tr>
+<td valign="top" >tv_mode_property</td>
+<td valign="top" >“mode”</td>
+<td valign="top" >DRM_MODE_PROP_ENUM</td>
+<td valign="top" >{0, "NTSC_M"} , {1, "NTSC_J"} ,
+
+{2, "NTSC_443"}, {3, "PAL_B"} etc.</td>
+<td valign="top" >Connector</td>
+<td valign="top" >TBD</td>
+</tr>
+
+<tr>
+<td valign="top" >tv_left_margin_property</td>
+<td valign="top" >“left margin”</td>
+<td valign="top" >DRM_MODE_PROP_RANGE</td>
+<td valign="top" >Min=0, Max=100</td>
+<td valign="top" >Connector</td>
+<td valign="top" >TBD</td>
+</tr>
+
+<tr>
+<td valign="top" >tv_right_margin_property</td>
+<td valign="top" >“right margin”</td>
+<td valign="top" >DRM_MODE_PROP_RANGE</td>
+<td valign="top" >Min=0, Max=100</td>
+<td valign="top" >Connector</td>
+<td valign="top" >TBD</td>
+</tr>
+
+<tr>
+<td valign="top" >tv_top_margin_property</td>
+<td valign="top" >“top margin”</td>
+<td valign="top" >DRM_MODE_PROP_RANGE</td>
+<td valign="top" >Min=0, Max=100</td>
+<td valign="top" >Connector</td>
+<td valign="top" >TBD</td>
+</tr>
+
+<tr>
+<td valign="top" >tv_bottom_margin_property</td>
+<td valign="top" >“bottom margin”</td>
+<td valign="top" >DRM_MODE_PROP_RANGE</td>
+<td valign="top" >Min=0, Max=100</td>
+<td valign="top" >Connector</td>
+<td valign="top" >TBD</td>
+</tr>
+
+<tr>
+<td valign="top" >tv_brightness_property</td>
+<td valign="top" >“brightness”</td>
+<td valign="top" >DRM_MODE_PROP_RANGE</td>
+<td valign="top" >Min=0, Max=100</td>
+<td valign="top" >Connector</td>
+<td valign="top" >TBD</td>
+</tr>
+
+<tr>
+<td valign="top" >tv_contrast_property</td>
+<td valign="top" >“contrast”</td>
+<td valign="top" >DRM_MODE_PROP_RANGE</td>
+<td valign="top" >Min=0, Max=100</td>
+<td valign="top" >Connector</td>
+<td valign="top" >TBD</td>
+</tr>
+
+<tr>
+<td valign="top" >tv_flicker_reduction_property</td>
+<td valign="top" >“flicker reduction”</td>
+<td valign="top" >DRM_MODE_PROP_RANGE</td>
+<td valign="top" >Min=0, Max=100</td>
+<td valign="top" >Connector</td>
+<td valign="top" >TBD</td>
+</tr>
+
+<tr>
+<td valign="top" >tv_overscan_property</td>
+<td valign="top" >“overscan”</td>
+<td valign="top" >DRM_MODE_PROP_RANGE</td>
+<td valign="top" >Min=0, Max=100</td>
+<td valign="top" >Connector</td>
+<td valign="top" >TBD</td>
+</tr>
+
+<tr>
+<td valign="top" >tv_saturation_property</td>
+<td valign="top" >“saturation”</td>
+<td valign="top" >DRM_MODE_PROP_RANGE</td>
+<td valign="top" >Min=0, Max=100</td>
+<td valign="top" >Connector</td>
+<td valign="top" >TBD</td>
+</tr>
+
+<tr>
+<td valign="top" >tv_hue_property</td>
+<td valign="top" >“hue”</td>
+<td valign="top" >DRM_MODE_PROP_RANGE</td>
+<td valign="top" >Min=0, Max=100</td>
+<td valign="top" >Connector</td>
+<td valign="top" >TBD</td>
+</tr>
+
+<tr>
+<td rowspan="2" valign="top" >Optional Properties</td>
+<td valign="top" >scaling_mode_property</td>
+<td valign="top" >“scaling mode”</td>
+<td valign="top" >DRM_MODE_PROP_ENUM</td>
+<td valign="top" >{ DRM_MODE_SCALE_NONE, "None" },
+{ DRM_MODE_SCALE_FULLSCREEN, "Full" },
+{ DRM_MODE_SCALE_CENTER, "Center" },
+{ DRM_MODE_SCALE_ASPECT, "Full aspect" }</td>
+<td valign="top" >Connector</td>
+<td valign="top" >TBD</td>
+</tr>
+
+<tr>
+<td valign="top" >dirty_info_property</td>
+<td valign="top" >“dirty”</td>
+<td valign="top" >DRM_MODE_PROP_ENUM | DRM_MODE_PROP_IMMUTABLE</td>
+<td valign="top" >{ DRM_MODE_DIRTY_OFF, "Off" },
+{ DRM_MODE_DIRTY_ON, "On" },
+{ DRM_MODE_DIRTY_ANNOTATE, "Annotate" }</td>
+<td valign="top" >Connector</td>
+<td valign="top" >TBD</td>
+</tr>
+
+<tr>
+<td rowspan="20" valign="top">i915</td>
+<td rowspan="2" valign="top">Generic</td>
+<td valign="top" >broadcast_rgb_property</td>
+<td valign="top" >"Broadcast RGB"</td>
+<td valign="top" >DRM_MODE_PROP_ENUM</td>
+<td valign="top" >{ INTEL_BROADCAST_RGB_AUTO, "Automatic" },
+{ INTEL_BROADCAST_RGB_FULL, "Full" },
+{ INTEL_BROADCAST_RGB_LIMITED, "Limited 16:235" }</td>
+<td valign="top" >Connector</td>
+<td valign="top" >TBD</td>
+</tr>
+
+<tr>
+<td valign="top" >force_audio_property</td>
+<td valign="top" >“audio”</td>
+<td valign="top" >DRM_MODE_PROP_ENUM</td>
+<td valign="top" >{ HDMI_AUDIO_OFF_DVI, "force-dvi" },
+{ HDMI_AUDIO_OFF, "off" },
+{ HDMI_AUDIO_AUTO, "auto" },
+{ HDMI_AUDIO_ON, "on" }</td>
+<td valign="top" >Connector</td>
+<td valign="top" >TBD</td>
+</tr>
+
+<tr>
+<td rowspan="17" valign="top">SDVO-TV</td>
+<td valign="top" >tv_format</td>
+<td valign="top" >“mode”</td>
+<td valign="top" >DRM_MODE_PROP_ENUM</td>
+<td valign="top" >{0, "NTSC_M"} , {1, "NTSC_J"} ,
+{2, "NTSC_443"}, {3, "PAL_B"} etc.</td>
+<td valign="top" >Connector</td>
+<td valign="top" >TBD</td>
+</tr>
+
+<tr>
+<td valign="top" >left</td>
+<td valign="top" >"left_margin"</td>
+<td valign="top" >DRM_MODE_PROP_RANGE</td>
+<td valign="top" >Min=0, Max= SDVO dependent</td>
+<td valign="top" >Connector</td>
+<td valign="top" >TBD</td>
+</tr>
+
+<tr>
+<td valign="top" >right</td>
+<td valign="top" >"right_margin"</td>
+<td valign="top" >DRM_MODE_PROP_RANGE</td>
+<td valign="top" >Min=0, Max= SDVO dependent</td>
+<td valign="top" >Connector</td>
+<td valign="top" >TBD</td>
+</tr>
+
+<tr>
+<td valign="top" >top</td>
+<td valign="top" >"top_margin"</td>
+<td valign="top" >DRM_MODE_PROP_RANGE</td>
+<td valign="top" >Min=0, Max= SDVO dependent</td>
+<td valign="top" >Connector</td>
+<td valign="top" >TBD</td>
+</tr>
+
+<tr>
+<td valign="top" >bottom</td>
+<td valign="top" >"bottom_margin"</td>
+<td valign="top" >DRM_MODE_PROP_RANGE</td>
+<td valign="top" >Min=0, Max= SDVO dependent</td>
+<td valign="top" >Connector</td>
+<td valign="top" >TBD</td>
+</tr>
+
+<tr>
+<td valign="top" >hpos</td>
+<td valign="top" >“hpos”</td>
+<td valign="top" >DRM_MODE_PROP_RANGE</td>
+<td valign="top" >Min=0, Max= SDVO dependent</td>
+<td valign="top" >Connector</td>
+<td valign="top" >TBD</td>
+</tr>
+
+<tr>
+<td valign="top" >vpos</td>
+<td valign="top" >“vpos”</td>
+<td valign="top" >DRM_MODE_PROP_RANGE</td>
+<td valign="top" >Min=0, Max= SDVO dependent</td>
+<td valign="top" >Connector</td>
+<td valign="top" >TBD</td>
+</tr>
+
+<tr>
+<td valign="top" >contrast</td>
+<td valign="top" >“contrast”</td>
+<td valign="top" >DRM_MODE_PROP_RANGE</td>
+<td valign="top" >Min=0, Max= SDVO dependent</td>
+<td valign="top" >Connector</td>
+<td valign="top" >TBD</td>
+</tr>
+
+<tr>
+<td valign="top" >saturation</td>
+<td valign="top" >“saturation”</td>
+<td valign="top" >DRM_MODE_PROP_RANGE</td>
+<td valign="top" >Min=0, Max= SDVO dependent</td>
+<td valign="top" >Connector</td>
+<td valign="top" >TBD</td>
+</tr>
+
+<tr>
+<td valign="top" >hue</td>
+<td valign="top" >“hue”</td>
+<td valign="top" >DRM_MODE_PROP_RANGE</td>
+<td valign="top" >Min=0, Max= SDVO dependent</td>
+<td valign="top" >Connector</td>
+<td valign="top" >TBD</td>
+</tr>
+
+<tr>
+<td valign="top" >sharpness</td>
+<td valign="top" >“sharpness”</td>
+<td valign="top" >DRM_MODE_PROP_RANGE</td>
+<td valign="top" >Min=0, Max= SDVO dependent</td>
+<td valign="top" >Connector</td>
+<td valign="top" >TBD</td>
+</tr>
+
+<tr>
+<td valign="top" >flicker_filter</td>
+<td valign="top" >“flicker_filter”</td>
+<td valign="top" >DRM_MODE_PROP_RANGE</td>
+<td valign="top" >Min=0, Max= SDVO dependent</td>
+<td valign="top" >Connector</td>
+<td valign="top" >TBD</td>
+</tr>
+
+<tr>
+<td valign="top" >flicker_filter_adaptive</td>
+<td valign="top" >“flicker_filter_adaptive”</td>
+<td valign="top" >DRM_MODE_PROP_RANGE</td>
+<td valign="top" >Min=0, Max= SDVO dependent</td>
+<td valign="top" >Connector</td>
+<td valign="top" >TBD</td>
+</tr>
+
+<tr>
+<td valign="top" >flicker_filter_2d</td>
+<td valign="top" >“flicker_filter_2d”</td>
+<td valign="top" >DRM_MODE_PROP_RANGE</td>
+<td valign="top" >Min=0, Max= SDVO dependent</td>
+<td valign="top" >Connector</td>
+<td valign="top" >TBD</td>
+</tr>
+
+<tr>
+<td valign="top" >tv_chroma_filter</td>
+<td valign="top" >“tv_chroma_filter”</td>
+<td valign="top" >DRM_MODE_PROP_RANGE</td>
+<td valign="top" >Min=0, Max= SDVO dependent</td>
+<td valign="top" >Connector</td>
+<td valign="top" >TBD</td>
+</tr>
+
+<tr>
+<td valign="top" >tv_luma_filter</td>
+<td valign="top" >“tv_luma_filter”</td>
+<td valign="top" >DRM_MODE_PROP_RANGE</td>
+<td valign="top" >Min=0, Max= SDVO dependent</td>
+<td valign="top" >Connector</td>
+<td valign="top" >TBD</td>
+</tr>
+
+<tr>
+<td valign="top" >dot_crawl</td>
+<td valign="top" >“dot_crawl”</td>
+<td valign="top" >DRM_MODE_PROP_RANGE</td>
+<td valign="top" >Min=0, Max=1</td>
+<td valign="top" >Connector</td>
+<td valign="top" >TBD</td>
+</tr>
+
+<tr>
+<td valign="top">SDVO-TV/LVDS</td>
+<td valign="top" >brightness</td>
+<td valign="top" >“brightness”</td>
+<td valign="top" >DRM_MODE_PROP_RANGE</td>
+<td valign="top" >Min=0, Max= SDVO dependent</td>
+<td valign="top" >Connector</td>
+<td valign="top" >TBD</td>
+</tr>
+
+<tr>
+<td rowspan="2" valign="top">CDV gma-500</td>
+<td rowspan="2" valign="top">Generic</td>
+<td valign="top" >broadcast_rgb_property</td>
+<td valign="top" >"Broadcast RGB"</td>
+<td valign="top" >DRM_MODE_PROP_ENUM</td>
+<td valign="top" >{ 0, “Full”},
+{ 1, “Limited 16:235”}</td>
+<td valign="top" >Connector</td>
+<td valign="top" >TBD</td>
+</tr>
+
+<tr>
+<td valign="top" >force_audio_property</td>
+<td valign="top" >"Broadcast RGB"</td>
+<td valign="top" >DRM_MODE_PROP_ENUM</td>
+<td valign="top" >{ -1, “off”},
+{ 0, “auto”},
+{ 1, “on”}</td>
+<td valign="top" >Connector</td>
+<td valign="top" >TBD</td>
+</tr>
+
+<tr>
+<td rowspan="19" valign="top">Poulsbo</td>
+<td valign="top">Generic</td>
+<td valign="top" >backlight_property</td>
+<td valign="top" >“backlight”</td>
+<td valign="top" >DRM_MODE_PROP_RANGE</td>
+<td valign="top" >Min=0, Max=100</td>
+<td valign="top" >Connector</td>
+<td valign="top" >TBD</td>
+</tr>
+
+<tr>
+<td rowspan="17" valign="top">SDVO-TV</td>
+<td valign="top" >tv_format</td>
+<td valign="top" >“mode”</td>
+<td valign="top" >DRM_MODE_PROP_ENUM</td>
+<td valign="top" >{0, "NTSC_M"} , {1, "NTSC_J"} ,
+{2, "NTSC_443"}, {3, "PAL_B"} etc.</td>
+<td valign="top" >Connector</td>
+<td valign="top" >TBD</td>
+</tr>
+
+<tr>
+<td valign="top" >left</td>
+<td valign="top" >"left_margin"</td>
+<td valign="top" >DRM_MODE_PROP_RANGE</td>
+<td valign="top" >Min=0, Max= SDVO dependent</td>
+<td valign="top" >Connector</td>
+<td valign="top" >TBD</td>
+</tr>
+
+<tr>
+<td valign="top" >right</td>
+<td valign="top" >"right_margin"</td>
+<td valign="top" >DRM_MODE_PROP_RANGE</td>
+<td valign="top" >Min=0, Max= SDVO dependent</td>
+<td valign="top" >Connector</td>
+<td valign="top" >TBD</td>
+</tr>
+
+<tr>
+<td valign="top" >top</td>
+<td valign="top" >"top_margin"</td>
+<td valign="top" >DRM_MODE_PROP_RANGE</td>
+<td valign="top" >Min=0, Max= SDVO dependent</td>
+<td valign="top" >Connector</td>
+<td valign="top" >TBD</td>
+</tr>
+
+<tr>
+<td valign="top" >bottom</td>
+<td valign="top" >"bottom_margin"</td>
+<td valign="top" >DRM_MODE_PROP_RANGE</td>
+<td valign="top" >Min=0, Max= SDVO dependent</td>
+<td valign="top" >Connector</td>
+<td valign="top" >TBD</td>
+</tr>
+
+<tr>
+<td valign="top" >hpos</td>
+<td valign="top" >“hpos”</td>
+<td valign="top" >DRM_MODE_PROP_RANGE</td>
+<td valign="top" >Min=0, Max= SDVO dependent</td>
+<td valign="top" >Connector</td>
+<td valign="top" >TBD</td>
+</tr>
+
+<tr>
+<td valign="top" >vpos</td>
+<td valign="top" >“vpos”</td>
+<td valign="top" >DRM_MODE_PROP_RANGE</td>
+<td valign="top" >Min=0, Max= SDVO dependent</td>
+<td valign="top" >Connector</td>
+<td valign="top" >TBD</td>
+</tr>
+
+<tr>
+<td valign="top" >contrast</td>
+<td valign="top" >“contrast”</td>
+<td valign="top" >DRM_MODE_PROP_RANGE</td>
+<td valign="top" >Min=0, Max= SDVO dependent</td>
+<td valign="top" >Connector</td>
+<td valign="top" >TBD</td>
+</tr>
+
+<tr>
+<td valign="top" >saturation</td>
+<td valign="top" >“saturation”</td>
+<td valign="top" >DRM_MODE_PROP_RANGE</td>
+<td valign="top" >Min=0, Max= SDVO dependent</td>
+<td valign="top" >Connector</td>
+<td valign="top" >TBD</td>
+</tr>
+
+<tr>
+<td valign="top" >hue</td>
+<td valign="top" >“hue”</td>
+<td valign="top" >DRM_MODE_PROP_RANGE</td>
+<td valign="top" >Min=0, Max= SDVO dependent</td>
+<td valign="top" >Connector</td>
+<td valign="top" >TBD</td>
+</tr>
+
+<tr>
+<td valign="top" >sharpness</td>
+<td valign="top" >“sharpness”</td>
+<td valign="top" >DRM_MODE_PROP_RANGE</td>
+<td valign="top" >Min=0, Max= SDVO dependent</td>
+<td valign="top" >Connector</td>
+<td valign="top" >TBD</td>
+</tr>
+
+<tr>
+<td valign="top" >flicker_filter</td>
+<td valign="top" >“flicker_filter”</td>
+<td valign="top" >DRM_MODE_PROP_RANGE</td>
+<td valign="top" >Min=0, Max= SDVO dependent</td>
+<td valign="top" >Connector</td>
+<td valign="top" >TBD</td>
+</tr>
+
+<tr>
+<td valign="top" >flicker_filter_adaptive</td>
+<td valign="top" >“flicker_filter_adaptive”</td>
+<td valign="top" >DRM_MODE_PROP_RANGE</td>
+<td valign="top" >Min=0, Max= SDVO dependent</td>
+<td valign="top" >Connector</td>
+<td valign="top" >TBD</td>
+</tr>
+
+<tr>
+<td valign="top" >flicker_filter_2d</td>
+<td valign="top" >“flicker_filter_2d”</td>
+<td valign="top" >DRM_MODE_PROP_RANGE</td>
+<td valign="top" >Min=0, Max= SDVO dependent</td>
+<td valign="top" >Connector</td>
+<td valign="top" >TBD</td>
+</tr>
+
+<tr>
+<td valign="top" >tv_chroma_filter</td>
+<td valign="top" >“tv_chroma_filter”</td>
+<td valign="top" >DRM_MODE_PROP_RANGE</td>
+<td valign="top" >Min=0, Max= SDVO dependent</td>
+<td valign="top" >Connector</td>
+<td valign="top" >TBD</td>
+</tr>
+
+<tr>
+<td valign="top" >tv_luma_filter</td>
+<td valign="top" >“tv_luma_filter”</td>
+<td valign="top" >DRM_MODE_PROP_RANGE</td>
+<td valign="top" >Min=0, Max= SDVO dependent</td>
+<td valign="top" >Connector</td>
+<td valign="top" >TBD</td>
+</tr>
+
+<tr>
+<td valign="top" >dot_crawl</td>
+<td valign="top" >“dot_crawl”</td>
+<td valign="top" >DRM_MODE_PROP_RANGE</td>
+<td valign="top" >Min=0, Max=1</td>
+<td valign="top" >Connector</td>
+<td valign="top" >TBD</td>
+</tr>
+
+<tr>
+<td valign="top">SDVO-TV/LVDS</td>
+<td valign="top" >brightness</td>
+<td valign="top" >“brightness”</td>
+<td valign="top" >DRM_MODE_PROP_RANGE</td>
+<td valign="top" >Min=0, Max= SDVO dependent</td>
+<td valign="top" >Connector</td>
+<td valign="top" >TBD</td>
+</tr>
+
+</tbody>
+</table>
   </sect1>
 
   <!-- Internals: vertical blanking -->